program demtool;

uses dos;

const NUMSW = 41;
const SW_DEMTIME = 1;
      SW_DEMSTATS = 2;
      SW_SDQIMP = 3;
      SW_CPRINT = 4;
      SW_DISC = 5;
      SW_BLEEDING = 6;
      SW_OUTPUT = 7;
      SW_UNIFORM = 8;
      SW_NOP = 9;
      SW_ENTITY = 10;
      SW_RUNES = 11;
      SW_GRENADE = 12;
      SW_CHAIN = 13;
      SW_INTERVAL = 14;
      SW_VISION = 15;
      SW_EXTRACT = 16;
      SW_FPS = 17;
      SW_HEADER = 18;
      SW_QDQSTATS = 19;
      SW_FADEOUT = 20;
      SW_FOOTER = 21;
      SW_DAMAGE = 22;
      SW_VCSHIFT = 23;
      SW_BLOCKNUM = 24;
      SW_REMBLOOD = 25;
      SW_PRINT = 26;
      SW_FILMAT11 = 27;
      SW_FAQPROXY = 28;
      SW_SETVIEW = 29;
      SW_SETPAUSE = 30;
      SW_SOUNDS = 31;
      SW_JAR = 32;
      SW_BFLASH = 33;
      SW_POWERUPS = 34;
      SW_AMBIENT = 35;
      SW_FADEIN = 36;
      SW_VOLUME = 37;
      SW_NOVINTER = 38;
      SW_SPEED = 39;
      SW_LIGHTON = 40;
      SW_WEIRD = 41;

var switch:array[1..NUMSW] of boolean;
    hipnotic:boolean;
    wpidx:array[0..255] of byte;
    pframe:array[0..31] of byte;
    p_unif:byte;
    p_chain:string;
    p_start,p_end:single;
    p_extract:string[40];
    p_fps:word;
    p_header:string;
    p_fadeout:word;
    p_footer:string;
    p_volume:single;

var stderr:text;
    errrec:textrec absolute stderr;

type header = record
                    len:longint;
                    a1,a2,a3:single;
              end;
     space = array[0..40000] of byte;

procedure printframe(what:word);
type s2=string[2];
var s:^word;
    i:word;
    health:integer;
    shells,nails,rockets,cells,weapon,armor:byte;
    items,atype:longint;
    weps,w2:string;
    weaponmodel:byte;
    numimp:word;
    found:boolean;

procedure setupdata;
begin
     i:=3;
     s:=@pframe[1];
     armor:=0;
     items:=$4001;
     if (s^ and $01)<>0 then inc(i);
     if (s^ and $02)<>0 then inc(i);
     if (s^ and $04)<>0 then inc(i);
     if (s^ and $20)<>0 then inc(i);
     if (s^ and $08)<>0 then inc(i);
     if (s^ and $40)<>0 then inc(i);
     if (s^ and $10)<>0 then inc(i);
     if (s^ and $80)<>0 then inc(i);
  (* if (s^ and $200)<>0 then begin *)
        move(pframe[i],items,4);
        inc(i,4);
  (* end; *)
     if (s^ and $1000)<>0 then inc(i);
     if (s^ and $2000)<>0 then begin
        armor:=pframe[i]; inc(i);
     end;
     if (s^ and $4000)<>0 then begin
        weaponmodel:=pframe[i]; inc(i);
     end;
     move(pframe[i],health,2);
     shells:=pframe[i+3];
     nails:=pframe[i+4];
     rockets:=pframe[i+5];
     cells:=pframe[i+6];
     inc(i,7);
     weapon:=wpidx[weaponmodel];
     atype:=0;
     if items and $002000<>0 then atype:=1;
     if items and $004000<>0 then atype:=2;
     if items and $008000<>0 then atype:=3;
end;

procedure p_demstats;

    procedure test(bit,ww:longint;b:s2);
    begin
         if items and bit<>0 then weps:=weps+b else weps:=weps+'  ';
         if weapon=ww then w2:=w2+' *' else w2:=w2+'  ';
    end;

begin
     weps:=''; w2:='';
     test($000001,2,' 2');
     test($000002,3,' 3');
     test($000004,4,' 4');
     test($000008,5,' 5');
     test($000010,6,' 6');
     if hipnotic then test($010000,0,' p');
     test($000020,7,' 7');
     test($000040,8,' 8');
     if hipnotic then test($800000,9,' 9');
     if hipnotic then test($000080,10,' 0');

     write(' Health:',health,' Armor:',armor);
     case atype of
          0:writeln;
          1:writeln(' Green');
          2:writeln(' Yellow');
          3:writeln(' Red');
     end;
     writeln(' Sh:',shells,' Nl:',nails,' Rk:',rockets,' Ce:',cells);
     writeln(weps);
     writeln(w2);
end;

procedure p_sdqimp;

var i:word;
    l:longint;

const qarray:array[1..8] of longint = (7,0,1,2,3,4,5,6);
      harray:array[0..10] of longint = (5,10,0,1,2,3,4,6,7,8,9);

begin
     if health<50 then health:=50;
     if health>100 then health:=100;
     if shells<25 then shells:=25;

     l:=1+(items and $7f) shr 1 + 64*(100-health) + 3264*longint(armor);
     if hipnotic then inc(l,656064*longint(harray[weapon]))
                 else inc(l,656064*longint(qarray[weapon]));
     writeln('registered ',l);
     writeln('sys_ticrate ',shells-25 + 76*nails + 15276*longint(rockets));
     l:=cells + 101*atype;
     if hipnotic then begin
        if (items and $000080)<>0 then inc(l,404);
        if (items and $800000)<>0 then inc(l,808);
        if (items and $010000)<>0 then inc(l,1616);
     end;
     writeln('temp1 ',l);
end;

begin
     setupdata;
     if what=SW_DEMSTATS then p_demstats;
     if what=SW_SDQIMP then p_sdqimp;
end;

procedure ewriteln(s:string);
begin
     writeln(stderr,s);
     close(stderr);
     halt(1);
end;

(*$I c:\turbo\source\demblock.pas *)

procedure dme_conv(file1,file2:string);

var track:string;
    f,f2:file;
    b:space;
    b2:^space;
    hdr:header;
    i,j,dp,prior:word;
    entity:word;
    modelindex,frame:byte;
    s:^word;
    time,itime:single;
    first,copied:boolean;
    newindex,talkindex:word;
    p_x,p_y,p_z:single;
    o_px,o_py,o_pz:single;
    save,take:byte;
    sspawn,tspawn,
    sdiff,tdiff:integer;
    health:word;
    pented:boolean;
    r:single;
    finale:boolean;
    runes:byte;
    cament,bspindex:word;
    camx,camy:integer;
    ex,ey,ez:integer;
    angle,cangle:single;
    printmode:boolean;
    ftt:file;
    skip:boolean;
    fptr:longint;
    toskip:word;
    remprint:boolean;
    ttime:single;
    timed:boolean;
    ftime:single;
    viewangle,oldview,oldangle:single;
    disc:boolean;
    othermsg:boolean;
    serverinfo:boolean;
    blocknum:longint;
    signonum:byte;
    jari:word;
    vol:single;
    distance:single;

    procedure getpcord(var c:single; var x:integer);
    begin
         move(b[i+1],x,2);
         inc(i,2);
         if entity=1 then c:=x/8;
    end;

    procedure addblood(num,col:word);
    var w:integer;
        function bound(x:single):shortint;
        begin
             x:=x*16;
             if x>127 then x:=127;
             if x<-128 then x:=-128;
             bound:=round(x);
        end;
    begin
         if num>255 then num:=255;
         b2^[dp]:=$12; (* particle *)
         w:=round(p_x)*8; move(w,b2^[dp+1],2);
         w:=round(p_y)*8; move(w,b2^[dp+3],2);
         w:=round(p_z+20)*8; move(w,b2^[dp+5],2);
         b2^[dp+7]:=bound(0);
         b2^[dp+8]:=bound(0);
         b2^[dp+9]:=bound(-4);
         b2^[dp+10]:=num;
         b2^[dp+11]:=col;
         inc(dp,12);
    end;

    procedure build_timetable;
    var i:word;
    begin
         rewrite(ftt,1);
         while not eof(f) do begin
               blockread(f,hdr,sizeof(hdr));
               blockread(f,b,hdr.len);
               if (b[hdr.len-1]=$1e) or (b[3]=$1e) then begin (* intermision *)
                  time:=-1;
                  itime:=ttime;
               end else if b[0]=$07 then begin (* time *)
                  move(b[1],ttime,4); time:=ttime;
               end else time:=0;
               blockwrite(ftt,time,4);
         end;
         time:=-2; blockwrite(ftt,time,4);
         ftime:=ttime;
         close(ftt);
    end;

    procedure findnextskip;
    begin
         blockread(ftt,angle,4);
         toskip:=1;
         cangle:=angle+1/p_fps;
         if signonum=3 then begin
            repeat
              fptr:=filepos(ftt);
              blockread(ftt,angle,4);
              if angle=-1 then begin
                 angle:=cangle+1;
                 dec(toskip);
                 dec(fptr,4);
              end else if angle<=0 then begin
                 while (angle=-1) or (angle=0) do blockread(ftt,angle,4);
                 if angle>cangle then begin
                    dec(toskip);
                    dec(fptr,4);
                 end else angle:=cangle+1;
              end else
                  if angle<=cangle then inc(toskip)
                  else begin
                       dec(toskip);
                       dec(fptr,4);
                  end;
            until angle>cangle;
            if toskip=0 then begin toskip:=1; inc(fptr,4); end;
            seek(ftt,fptr);
         end;
    end;

    procedure insert_demo(s:string);
    var c:char;
    begin
         fptr:=filepos(f);
         close(f);
         assign(f,s); reset(f,1);
         repeat blockread(f,c,1) until c=#10;
         while not eof(f) do begin
               blockread(f,hdr,sizeof(hdr));
               blockwrite(f2,hdr,sizeof(hdr));
               blockread(f,b,hdr.len);
               blockwrite(f2,b,hdr.len);
         end;
         close(f);
         assign(f,file1); reset(f,1);
         seek(f,fptr);
    end;

    type t_entco = array[0..1023] of record x,y:integer; w:boolean; end;
    var  ec:^t_entco;

begin
     assign(f,file1);     reset(f,1);
     assign(f2,file2);    rewrite(f2,1);
     if diskfree(0)<filesize(f) then begin
        writeln(stderr,'demtool: no space left on device');
        close(f);
        close(f2);
        exit;
     end;
     getmem(b2,40000);
     i:=0;
     hipnotic:=false;
     first:=false;
     printmode:=false;
     finale:=false;
     repeat inc(i); blockread(f,track[i],1);
     until track[i]=#10;
     blockwrite(f2,track[1],i);
     if switch[SW_OUTPUT] then begin
        track[0]:=char(i-1);
        writeln;
        writeln('track "',track,'\n";');
     end;
     if switch[SW_HEADER] then insert_demo(p_header);
     if switch[SW_VISION] then begin
        getmem(ec,sizeof(ec^));
        fillchar(ec^,sizeof(ec^),#0);
        ec^[1].w:=true;
     end;
     sspawn:=0; tspawn:=0;
     if switch[SW_NOP] then begin
        hdr.len:=1; b2^[0]:=$1; (* nop *)
        hdr.a1:=0; hdr.a2:=0; hdr.a3:=0;
        blockwrite(f2,hdr,sizeof(hdr));
        blockwrite(f2,b2^,hdr.len);
     end;
     if switch[SW_FPS] or switch[SW_FADEOUT] then begin
        fptr:=filepos(f);
        assign(ftt,'tmp.###');
        build_timetable;
        reset(ftt,1);
        seek(f,fptr);
     end;
     skip:=false;
     time:=0; itime:=0;
     blocknum:=0;
     signonum:=0;
     cament:=0;
     distance:=0;
     serverinfo:=false;
     p_x:=0; p_y:=0; p_z:=0;
     o_px:=-1;
     sdiff:=0; tdiff:=0;
     while not eof(f) do begin
           blockread(f,hdr,sizeof(hdr));
           blockread(f,b,hdr.len);
           if switch[SW_OUTPUT] then
              if not switch[SW_INTERVAL] or (signonum<3)
                     or ((time>=p_start) and (time<=p_end)) then
                        output_block(b,hdr);
           if switch[SW_FPS] and not skip then findnextskip;
           i:=0; if not skip then dp:=0;
           remprint:=false;
           timed:=false;
           disc:=false;
           othermsg:=false;
           if itime=0 then begin
              oldview:=viewangle;
              viewangle:=hdr.a2;
           end else if hdr.a2<>oldangle then viewangle:=oldangle
                                        else viewangle:=oldview;
           repeat
             copied:=false;
             prior:=i;
             case b[i] of
                $00: begin (* bad *)
                     end;
                $01: begin (* nop *)
                     end;
                $02: begin (* disconnect *)
                           disc:=true;
                           if switch[SW_FADEOUT] then begin
                              j:=hdr.len;
                              if p_fadeout<>0 then
                                 time:=ttime-0.9
                              else
                                 time:=ttime+0.1;
                              track:=#7'    '#9'v_cshift 0 0 0 255'#10#0;
                              hdr.len:=length(track);
                              for entity:=0 to 2 do begin
                                  move(time,track[2],4);
                                  blockwrite(f2,hdr,sizeof(hdr));
                                  blockwrite(f2,track[1],hdr.len);
                                  time:=time+0.1;
                              end;
                              hdr.len:=j;
                           end;
                           if switch[SW_CHAIN] then begin
                              track:=#9'playdemo '+p_chain+#10#0;
                              move(track[1],b2^[dp],length(track));
                              inc(dp,length(track));
                           end;
                     end;
                $03: begin (* updatestat *)
                           inc(i,5);
                     end;
                $04: begin (* version *)
                           inc(i,4);
                     end;
                $05: begin (* setview *)
                           move(b[i+1],j,2);
                           if switch[SW_SETVIEW] and (j=cament)
                              then copied:=true
                              else cament:=j;
                           inc(i,2);
                     end;
                $06: begin (* sound *)
                           j:=b[i+1];
                           vol:=255;
                           if (j and $1)<>0 then begin
                              vol:=b[i+2]; inc(i);
                           end;
                           if switch[SW_VOLUME] then begin
                              vol:=vol*p_volume;
                              b2^[dp]:=$06; (* sound *)
                              b2^[dp+1]:=j or $01;
                              b2^[dp+2]:=trunc(vol);
                              move(b[i+2],b2^[dp+3],9+word((j and $2)<>0));
                              inc(dp,12+word((j and $2)<>0));
                              copied:=true;
                           end;
                           if (j and $2)<>0 then inc(i);
                           if switch[SW_CPRINT] and (b[i+4]=talkindex)
                              then copied:=true;
                           if switch[SW_SOUNDS] then copied:=true;
                           inc(i,10);
                     end;
                $07: begin (* time *)
                           move(b[i+1],time,4);
                           timed:=true;
                           if switch[SW_DEMTIME] then begin
                              str(time:5:3,track);
                              track:=track+#0;
                              b2^[dp]:=$1a;   (* centerprint *)
                              move(track[1],b2^[dp+1],length(track));
                              inc(dp,length(track)+1);
                           end;
                           if switch[SW_BLOCKNUM] then begin
                              str(blocknum,track);
                              track:=#$1a'['+track+']  '; (* centerprint *)
                              move(track[1],b2^[dp],length(track));
                              inc(dp,length(track));
                              r:=time;
                              if r>=60 then begin
                                 str(trunc(r/60),track);
                                 track:=track+':';
                                 move(track[1],b2^[dp],length(track));
                                 inc(dp,length(track));
                                 while r>=60 do r:=r-60;
                              end;
                              str(r:5:3,track);
                              track:=track+#0;
                              move(track[1],b2^[dp],length(track));
                              inc(dp,length(track));
                           end;
                           if switch[SW_BLEEDING] and (signonum=3) and (itime=0)
                           then begin
                              r:=random(100)/100;
                              if (health<100) and (r<exp(1.3*ln(1-health/100)))
                              and not pented then addblood(round(sqrt(r*20)),73);
                           end;
                           if skip then copied:=true;
                           inc(i,4);
                     end;
                $08: begin (* print *)
                           j:=i;
                           repeat inc(i) until b[i]=0;
                           if switch[SW_PRINT] then begin
                              move(b[j+1],track[1],9);
                              track[0]:=#9;
                              if track<>#2#10'VERSION' then copied:=true;
                           end;
                           if switch[SW_QDQSTATS] and (i-j>1) then begin
                              move(b[j+1],track[1],i-j-1);
                              track[0]:=char(i-j-1);
                              if pos('Stats patch',track)>0 then remprint:=true;
                              if track='Playing on ' then remprint:=true;
                              if remprint then copied:=true;
                           end;
                           if switch[SW_SETPAUSE] and (i-j>1) then begin
                              move(b[j+1],track[1],i-j-1);
                              track[0]:=char(i-j-1);
                              if pos('paused the game',track)>0
                                 then copied:=true;
                           end;
                     end;
                $09: begin (* stufftext *)
                           j:=i;
                           repeat inc(i) until b[i]=0;
                           if switch[SW_VCSHIFT] and (i-j>1) then begin
                              move(b[j+1],track[1],i-j-1);
                              track[0]:=#8;
                              if track='v_cshift' then copied:=true;
                           end;
                           if switch[SW_BFLASH] and (i-j>1) then begin
                              move(b[j+1],track[1],3);
                              track[0]:=#3;
                              if track='bf'#10 then copied:=true;
                           end;
                     end;
                $0a: begin (* setangle *)
                           oldangle:=viewangle;
                           viewangle:=b[i+2]/256*320;
                           o_px:=-1;
                           inc(i,3);
                     end;
                $0b: begin (* serverinfo *)
                           inc(i,6);
                           serverinfo:=true;
                           repeat inc(i) until b[i]=0;
                           newindex:=0;
                           bspindex:=1;
                           repeat j:=i;
                                  inc(newindex);
                                  repeat inc(i) until b[i]=0;
                                  if newindex=1 then begin
                                     move(b[j+6],track[1],i-j-10);
                                     track[0]:=char(i-j-10);
                                     if switch[SW_DEMSTATS] then
                                              writeln('< ',track,' >');
                                     hipnotic:=track[1]='h';
                                     case track[2] of
                                      '2': runes:=$10;
                                      '3': runes:=$30;
                                      '4': runes:=$70;
                                      'n': runes:=$f0;
                                      else runes:=0;
                                     end;
                                     if p_chain='' then begin
                                        p_chain:=track;
                                        inc(p_chain[byte(track[0])]);
                                     end;
                                  end;
                                  move(b[j+1],track[1],i-j-1);
                                  track[0]:=char(i-j-1);
                                  if track[1]='*' then inc(bspindex);
                                  if track='progs/v_axe.mdl' then wpidx[newindex]:=1
                                  else if track='progs/v_shot.mdl' then wpidx[newindex]:=2
                                  else if track='progs/v_shot2.mdl' then wpidx[newindex]:=3
                                  else if track='progs/v_nail.mdl' then wpidx[newindex]:=4
                                  else if track='progs/v_nail2.mdl' then wpidx[newindex]:=5
                                  else if track='progs/v_rock.mdl' then wpidx[newindex]:=6
                                  else if track='progs/v_rock2.mdl' then wpidx[newindex]:=7
                                  else if track='progs/v_light.mdl' then wpidx[newindex]:=8
                                  else if track='progs/v_prox.mdl' then wpidx[newindex]:=0
                                  else if track='progs/v_laserg.mdl' then wpidx[newindex]:=9
                                  else if track='progs/v_hammer.mdl' then wpidx[newindex]:=10;
                           until i-j=1;
                           newindex:=0;
                           repeat j:=i;
                                  inc(newindex);
                                  repeat inc(i) until b[i]=0;
                                  move(b[j+1],track[1],i-j-1);
                                  track[0]:=char(i-j-1);
                                  if track='misc/talk.wav' then talkindex:=newindex;
                           until i-j=1;
                     end;
                $0c: begin (* lightstyle *)
                           inc(i);
                           repeat inc(i) until b[i]=0;
                     end;
                $0d: begin (* updatename *)
                           inc(i);
                           repeat inc(i) until b[i]=0;
                     end;
                $0e: begin (* updatefrags *)
                           inc(i,3);
                     end;
                $0f: begin (* clientdata *)
                           jari:=0;
                           inc(i);
                           s:=@b[i];
                           inc(i,2);
                           if (s^ and $01)<>0 then inc(i);
                           if (s^ and $02)<>0 then inc(i);
                           if (s^ and $04)<>0 then begin jari:=i; inc(i) end;
                           if (s^ and $20)<>0 then inc(i);
                           if (s^ and $08)<>0 then inc(i);
                           if (s^ and $40)<>0 then inc(i);
                           if (s^ and $10)<>0 then inc(i);
                           if (s^ and $80)<>0 then inc(i);
                           pented:=(b[i+2] and $10)<>0;
                        (* if (s^ and $200)<>0 then *) inc(i,4);
                           entity:=i-prior-1;
                           if (s^ and $1000)<>0 then inc(i);
                           if (s^ and $2000)<>0 then inc(i);
                           if (s^ and $4000)<>0 then inc(i);
                           move(b[i],health,2);
                           inc(i,7);
                           move(b[prior],pframe[0],i-prior+1);
                           if not first and switch[SW_DEMSTATS] then begin
                              writeln('Start stats:');
                              printframe(SW_DEMSTATS);
                              first:=true;
                           end;
                           if switch[SW_RUNES] then begin
                              move(b[prior],b2^[dp],i-prior+1);
                              b2^[dp+entity]:=b2^[dp+entity] or runes;
                              inc(dp,i-prior+1);
                              copied:=true;
                           end;
                           if switch[SW_JAR] and (jari<>0) then begin
                              move(b[prior],b2^[dp],i-prior+1);
                              b2^[dp+jari-prior]:=0;
                              inc(dp,i-prior+1);
                              copied:=true;
                           end;
                           if switch[SW_POWERUPS] then begin
                              move(b[prior],b2^[dp],i-prior+1);
                              b2^[dp+entity-1]:=b2^[dp+entity-1] and not $78;
                              inc(dp,i-prior+1);
                              copied:=true;
                           end;
                           if skip then copied:=true;
                     end;
                $10: begin (* stopsound *)
                           inc(i,2);
                     end;
                $11: begin (* updatecolors *)
                           inc(i,2);
                           if switch[SW_UNIFORM] then begin
                              b2^[dp]:=$11;
                              b2^[dp+1]:=b[i-1];
                              b2^[dp+2]:=p_unif;
                              inc(dp,3);
                              copied:=true;
                           end;
                     end;
                $12: begin (* particle *)
                           inc(i,11);
                           if switch[SW_REMBLOOD] and not othermsg
                              and (itime<>0)
                           then copied:=true;
                     end;
                $13: begin (* damage *)
                           save:=b[i+1];
                           take:=b[i+2];
                           inc(i,8);
                           inc(sspawn,save*3); inc(sdiff,save);
                           inc(tspawn,take*3); inc(tdiff,take);
                           if switch[SW_DAMAGE] then copied:=true;
                     end;
                $14: begin (* spawnstatic *)
                           inc(i,13);
                     end;
                $15: begin (* spawnbinary *)
                     end;
                $16: begin (* spawnbaseline *)
                           if switch[SW_VISION] then begin
                              move(b[i+1],j,2);
                              if j<>1 then ec^[j].w:=b[i+3]<=bspindex;
                              move(b[i+7],ec^[j].x,2);
                              move(b[i+10],ec^[j].y,2);
                           end;
                           if switch[SW_FILMAT11] then begin
                              if b[i+3]=0 then copied:=true;
                           end;
                           if switch[SW_WEIRD] then begin
                              if random(100)<30 then b[i+3]:=1;
                           end;
                           inc(i,15);
                     end;
                $17: begin (* temp_entity *)
                           inc(i);
                           if (b[i]=5) or (b[i]=6) or (b[i]=9) or (b[i]=13)
                              then inc(i,14)
                           else if b[i]=12 then inc(i,8)
                           else inc(i,6);
                     end;
                $18: begin (* setpause *)
                           inc(i);
                           if switch[SW_SETPAUSE] then copied:=true;
                     end;
                $19: begin (* signon *)
                           inc(i);
                           signonum:=b[i];
                     end;
                $1a: begin (* centerprint *)
                           j:=i;
                           repeat inc(i) until b[i]=0;
                           if switch[SW_CPRINT] then copied:=true;
                           if switch[SW_GRENADE] then begin
                              move(b[j+1],track[1],8);
                              track[0]:=#8;
                              if track='Grenade ' then copied:=true;
                           end;
                           if switch[SW_EXTRACT] and (i>j+1) then begin
                              move(b[j+1],track[1],i-j-1);
                              track[0]:=char(i-j-1);
                              if track='<'+p_extract+'>' then
                                 printmode:=true
                              else if track='</'+p_extract+'>' then begin
                                 printmode:=false; writeln;
                              end else if printmode then write(track);
                           end;
                     end;
                $1b: begin (* killedmonster *)
                     end;
                $1c: begin (* foundsecret *)
                     end;
                $1d: begin (* spawnstaticsound *)
                           inc(i,9);
                           if switch[SW_AMBIENT] then copied:=true;
                     end;
                $1e: begin (* intermission *)
                           if itime=0 then itime:=time;
                           if p_fadeout<>0 then ftime:=itime+p_fadeout;
                     end;
                $1f: begin (* finale *)
                           finale:=true;
                           if itime=0 then itime:=time;
                           repeat inc(i) until b[i]=0;
                     end;
                $20: begin (* cdtrack *)
                           inc(i,2);
                     end;
                $21: begin (* sellscreen *)
                     end;
                $22: begin (* cutscene *)
                           if itime=0 then itime:=time;
                           repeat inc(i) until b[i]=0;
                     end;
                $80..$ff:
                     begin (* updateentity *)
                           j:=b[i] and $7f;
                           if (j and $01)<>0 then begin
                              inc(i); j:=j or (b[i] shl 8);
                           end;
                           inc(i);
                           if (j and $4000)<>0 then begin
                              move(b[i],entity,2); inc(i);
                           end else begin
                              entity:=b[i];
                           end;
                           modelindex:=0; frame:=0;
                           if (j and $0400)<>0 then begin
                              inc(i); modelindex:=b[i];
                           end;
                           if (j and $0040)<>0 then begin
                              inc(i); frame:=b[i];
                           end;
                           if entity=1 then begin
                              p_x:=0; p_y:=0; p_z:=0;
                           end;
                           if (j and $0800)<>0 then inc(i);
                           if (j and $1000)<>0 then inc(i);
                           if (j and $2000)<>0 then inc(i);
                           if (j and $0002)<>0 then getpcord(p_x,ex);
                           if (j and $0100)<>0 then inc(i);
                           if (j and $0004)<>0 then getpcord(p_y,ey);
                           if (j and $0010)<>0 then inc(i);
                           if (j and $0008)<>0 then getpcord(p_z,ez);
                           if (j and $0200)<>0 then inc(i);
                           if switch[SW_SPEED]
                              and (entity=1) and (itime=0) then begin
                              if o_px<>-1 then
                                 distance:=distance+sqrt(sqr(p_x-o_px)
                                            +sqr(p_y-o_py)+sqr(p_z-o_pz));
                              o_px:=p_x; o_py:=p_y; o_pz:=p_z;
                           end;
                           if switch[SW_VISION] and
                            ((itime=0) or not switch[SW_NOVINTER]) then begin
                              if entity=cament then begin
                                 if (j and $0002)<>0 then camx:=ex else camx:=0;
                                 if (j and $0004)<>0 then camy:=ey else camy:=0;
                              end else begin
                                 cangle:=viewangle;
                                 if (j and $0002)=0 then ex:=ec^[entity].x;
                                 if (j and $0004)=0 then ey:=ec^[entity].y;
                                 ex:=ex-camx; ey:=ey-camy;
                                 if ex=0 then begin
                                    angle:=90; if ey<0 then angle:=-90;
                                 end else begin
                                    angle:=arctan(ey/ex)*180/pi;
                                    if ex<0 then angle:=angle+180;
                                 end;
                                 while angle>=180 do angle:=angle-360;
                                 while cangle>=180 do cangle:=cangle-360;
                                 angle:=abs(angle-cangle);
                                 if angle>180 then angle:=abs(angle-360);
                                 if (angle>80+integer(itime<>0)*10)
                                    and not ec^[entity].w
                                    and (abs(ex)+abs(ey)>600)
                                 then copied:=true;
                              end;
                           end;
                           if entity=1 then begin
                              if switch[SW_BLEEDING] and (sspawn+tspawn>0) then
                              begin
                                 if sspawn<>0 then addblood(sspawn,3);
                                 if tspawn<>0 then begin
                                    if pented then addblood(tspawn,145)
                                              else addblood(tspawn,73);
                                 end;
                                 dec(sspawn,sdiff);
                                 dec(tspawn,tdiff);
                                 if sspawn<=0 then begin sspawn:=0; sdiff:=0; end;
                                 if tspawn<=0 then begin tspawn:=0; tdiff:=0; end;
                              end;
                           end else
                             if finale and switch[SW_ENTITY] then copied:=true;
                           if skip then copied:=true;
                     end;
             end;
             inc(i);
             if not copied then begin
                move(b[prior],b2^[dp],i-prior);
                inc(dp,i-prior);
             end;
          until i>=hdr.len;
          inc(blocknum);
          othermsg:=true;
          if switch[SW_FPS] then begin
             dec(toskip);
             skip:=toskip>0;
          end;
          if switch[SW_FADEIN] and timed and (time>=1.4) and (time<2.0) then
          begin
             str(trunc((1.9-time)/0.5*255),track);
             if time>1.9 then track:='0';
             track:=#9'v_cshift 0 0 0 '+track+#10#0;
             move(track[1],b2^[dp],length(track));
             inc(dp,length(track));
          end;
          if switch[SW_LIGHTON] and (time>0) and (time<1.5) then
          begin
             track:=#9'v_cshift 0 0 0 0'#10#0;
             move(track[1],b2^[dp],length(track));
             inc(dp,length(track));
          end;
          if switch[SW_FADEOUT] and timed and (time>ftime-0.5) then begin
             str(trunc((time+0.5-ftime)/0.5*255),track);
             if time>ftime then track:='255';
             track:=#9'v_cshift 0 0 0 '+track+#10#0;
             move(track[1],b2^[dp],length(track));
             inc(dp,length(track));
          end;
          if switch[SW_FOOTER] and disc then insert_demo(p_footer);
          if (dp<>0) and not skip then
             if not switch[SW_INTERVAL] or (time<1.4)
                    or ((time>=p_start) and (time<=p_end)) then
             if not switch[SW_FADEOUT] or not timed or (itime=0)
                    or (p_fadeout=0) or (time<=itime+p_fadeout) then
             if not switch[SW_FAQPROXY] or serverinfo then
          begin
             hdr.len:=dp;
             blockwrite(f2,hdr,sizeof(hdr));
             blockwrite(f2,b2^,hdr.len);
          end;
          if switch[SW_FADEOUT] and timed and (time>ftime-0.5) then
             dec(dp,length(track));
          if switch[SW_FADEOUT] and (time=ttime) and (p_fadeout<>0)
                                and (time<itime+p_fadeout) then begin
             repeat
                   time:=time+0.1;
                   move(time,b2^[1],4);
                   if (time>ftime-0.5) and (time<=ftime) then begin
                      str(trunc((time+0.5-ftime)/0.5*255),track);
                      if time>ftime then track:='255';
                      track:=#9'v_cshift 0 0 0 '+track+#10#0;
                      move(track[1],b2^[dp],length(track));
                      inc(dp,length(track));
                   end;
                   hdr.len:=dp;
                   blockwrite(f2,hdr,sizeof(hdr));
                   blockwrite(f2,b2^,hdr.len);
                   if (time>ftime-0.5) and (time<=ftime) then
                      dec(dp,length(track));
             until time>itime+p_fadeout;
             ttime:=time+1;
          end;
     end;
     if switch[SW_DISC] then begin
        hdr.len:=1; b2^[0]:=$2; (* disconnect *)
        blockwrite(f2,hdr,sizeof(hdr));
        blockwrite(f2,b2^,hdr.len);
        if switch[SW_OUTPUT] then begin
           b[0]:=$2; output_block(b,hdr);
        end;
     end;
     close(f);
     close(f2);
     if switch[SW_DEMSTATS] then begin
        if itime=0 then itime:=time;
        writeln('End:  (',trunc(itime*1000)/1000:5:3,')');
        printframe(SW_DEMSTATS);
     end;
     if switch[SW_SDQIMP] then printframe(SW_SDQIMP);
     if switch[SW_VISION] then freemem(ec,sizeof(ec^));
     if switch[SW_FPS] or switch[SW_FADEOUT] then begin
        close(ftt); erase(ftt);
     end;
     if switch[SW_SPEED] then begin
        if itime=0 then itime:=time;
        write('Distance: ',distance:5:2,'  Time: ',itime:5:2,
                         '  Speed: ',(distance/(itime-1.4)):5:2);
     end;
     freemem(b2,40000);
end;

procedure append_dem(var s:string);
var i:word;
    b:boolean;
begin
     b:=true;
     for i:=1 to length(s) do
         if s[i]='.' then b:=false
         else if s[i]='\' then b:=true;
     if b then s:=s+'.dem';
end;

procedure parseargs(var pp:word);
var s,t:string;
    i:word;
    j,p:integer;
    sr:searchrec;
begin
     for i:=1 to NUMSW do switch[i]:=false;
     pp:=0;
     repeat
           inc(pp);
           if pp>paramcount then exit;
           s:=paramstr(pp);
           if s[1]<>'-' then exit;
           s[length(s)+1]:='x';
           for i:=2 to length(s) do case s[i] of
             't': switch[SW_DEMTIME]:=true;
             's': switch[SW_DEMSTATS]:=true;
             'i': switch[SW_SDQIMP]:=true;
             'c': switch[SW_CPRINT]:=true;
             'd': switch[SW_DISC]:=true;
             'b': switch[SW_BLEEDING]:=true;
             'w': switch[SW_OUTPUT]:=true;
             'u': begin switch[SW_UNIFORM]:=true;
                        t:=copy(s,i+1,length(s)-i);
                        val(t,p_unif,j);
                        i:=length(s);
                  end;
             'n': switch[SW_NOP]:=true;
             'e': switch[SW_ENTITY]:=true;
             'r': switch[SW_RUNES]:=true;
             'g': switch[SW_GRENADE]:=true;
             'p': begin switch[SW_CHAIN]:=true;
                        p_chain:=copy(s,i+1,length(s)-i);
                        i:=length(s);
                  end;
             '0'..'9': begin switch[SW_INTERVAL]:=true;
                        t:=copy(s,i,length(s)-i+1);
                        p:=pos(':',t);
                        if p=0 then begin t:=t+':'; p:=length(t); end;
                        if p<>1 then val(copy(t,1,p-1),p_start,j)
                        else p_start:=0;
                        if p<>length(t) then val(copy(t,p+1,length(t)-p),p_end,j)
                        else p_end:=1E6;
                        i:=length(s);
                  end;
             'v': switch[SW_VISION]:=true;
             'x': begin switch[SW_EXTRACT]:=true;
                        p_extract:=copy(s,i+1,length(s)-i);
                        i:=length(s);
                  end;
             'f': begin switch[SW_FPS]:=true;
                        if (s[i+1]>='0') and (s[i+1]<='9') then begin
                           p_fps:=0;
                           while (s[i+1]>='0') and (s[i+1]<='9') do begin
                                 inc(i);
                                 p_fps:=p_fps*10+ord(s[i])-ord('0');
                           end;
                        end else p_fps:=20;
                  end;
             'h': begin switch[SW_HEADER]:=true;
                        p_header:=copy(s,i+1,length(s)-i);
                        i:=length(s);
                        if p_header='' then p_header:='header';
                        append_dem(p_header);
                        findfirst(p_header,archive,sr);
                        if doserror<>0 then
                           ewriteln('demtool: '+p_header+' not found');
                  end;
             'q': switch[SW_QDQSTATS]:=true;
             'o': begin switch[SW_FADEOUT]:=true;
                        p_fadeout:=0;
                        if (s[i+1]>='0') and (s[i+1]<='9') then begin
                           while (s[i+1]>='0') and (s[i+1]<='9') do begin
                                 inc(i);
                                 p_fadeout:=p_fadeout*10+ord(s[i])-ord('0');
                           end;
                        end;
                  end;
             'a': begin switch[SW_FOOTER]:=true;
                        p_footer:=copy(s,i+1,length(s)-i);
                        i:=length(s);
                        if p_footer='' then p_footer:='footer';
                        append_dem(p_footer);
                        findfirst(p_footer,archive,sr);
                        if doserror<>0 then
                           ewriteln('demtool: '+p_footer+' not found');
                  end;
             'P': switch[SW_SETPAUSE]:=true;
             '-': begin i:=length(s);
                        if s='--damage' then switch[SW_DAMAGE]:=true
                        else if s='--vcshift' then switch[SW_VCSHIFT]:=true
                        else if s='--blood' then switch[SW_REMBLOOD]:=true
                        else if s='--faqproxy' then switch[SW_FAQPROXY]:=true
                        else if s='--setview' then switch[SW_SETVIEW]:=true
                        else if s='--sounds' then switch[SW_SOUNDS]:=true
                        else if s='--bf' then switch[SW_BFLASH]:=true
                        else if s='--powerups' then switch[SW_POWERUPS]:=true
                        else if s='--ambient' then switch[SW_AMBIENT]:=true
                        else if s='--fadein' then switch[SW_FADEIN]:=true
                        else if s='--speed' then switch[SW_SPEED]:=true
                        else if s='--lighton' then switch[SW_LIGHTON]:=true
                        else if s='--weird' then switch[SW_WEIRD]:=true
                        else ewriteln('demtool: unknown switch '+s);
                  end;
             'T': switch[SW_BLOCKNUM]:=true;
             'm': switch[SW_PRINT]:=true;
             '@': switch[SW_FILMAT11]:=true;
             'j': switch[SW_JAR]:=true;
             'V': begin switch[SW_VOLUME]:=true;
                        t:=copy(s,i+1,length(s)-i);
                        val(t,p_volume,j);
                        i:=length(s);
                  end;
             'I': switch[SW_NOVINTER]:=true;
            else
              ewriteln('demtool: unknown switch '+s[i]);
           end;
     until false;
end;

procedure usage;
begin
     writeln(stderr,'demtool [-{bcdegimnqrstTvw}] [-[from]:[to]] [-a[demo]] [-f[fps]] [-h[demo]]');
     writeln(stderr,'        [-o[sec]] [-p[demo]] [-u<color>] [-x<string>] [files [outfile]]');
     writeln(stderr,'');
     writeln(stderr,' -a: Insert demo.dem before disconnect  -b: Add bleeding to player model');
     writeln(stderr,' -c: Remove centerprinted messages      -d: Add a disconnect at the end');
     writeln(stderr,' -e: Remove entities during finale      -f: Set framerate to fps (default 20)');
     writeln(stderr,' -g: Remove grenade counter messages    -h: Insert demo.dem at start of files');
     writeln(stderr,' -i: Print impulses for QdQStats        -m: Remove messages at top of screen');
     writeln(stderr,' -n: Add a nop block at the start       -o: Fade-out, cut intermission to sec');
     writeln(stderr,' -p: Add playdemo before disconnect     -q: Remove QdQStats message');
     writeln(stderr,' -r: Add runes to player''s inventory    -s: Print statistics and time');
     writeln(stderr,' -t: Centerprint time on every frame    -T: Centerprint blocknum and time');
     writeln(stderr,' -u: Change player''s uniform to color   -v: Remove entities outside fov');
     writeln(stderr,' -w: Produce lmpc-style output          -x: Extract messages tagged by <string>');
     writeln(stderr,' -@: Fix demos for Film At 11           -[from]:[to]: Restrict output to range');
     writeln(stderr,'');
     writeln(stderr,'Wildcards in files are ok. Default is *.dem. Specifying outfile will only');
     writeln(stderr,'work if a single demo is given through `files''. If outfile is not given');
     writeln(stderr,'the input files will be changed. Multiple switches can be combined.');
     close(stderr);
     halt(1);
end;

var sr:searchrec;
    i,num,j,pp:word;
    f:file;
    dirpath,outname:string;
    reg:registers;
    stdout:file;
    stdrec:filerec absolute stdout;
    levels:array[1..200] of string[12];
    rewriting,printing,outfile:boolean;
begin
     assign(stderr,'tmp_err.$$$');
     rewrite(stderr);
     reg.ah:=$46;
     reg.bx:=2; reg.cx:=errrec.handle;
     intr($21,reg);
     assign(stdout,'tmp_err.$$$'); erase(stdout);
     if paramcount=0 then usage;
     parseargs(pp);
     if pp=1 then switch[SW_DEMSTATS]:=true;
     rewriting:=switch[SW_DEMTIME] or switch[SW_CPRINT] or switch[SW_BLEEDING]
             or switch[SW_UNIFORM] or switch[SW_NOP] or switch[SW_ENTITY]
             or switch[SW_RUNES] or switch[SW_GRENADE] or switch[SW_CHAIN]
             or (switch[SW_INTERVAL] and not switch[SW_OUTPUT])
             or (switch[SW_DISC] and not switch[SW_OUTPUT])
             or switch[SW_VISION] or switch[SW_FPS] or switch[SW_HEADER]
             or switch[SW_QDQSTATS] or switch[SW_FADEOUT] or switch[SW_FOOTER]
             or switch[SW_DAMAGE] or switch[SW_VCSHIFT] or switch[SW_BLOCKNUM]
             or switch[SW_REMBLOOD] or switch[SW_PRINT] or switch[SW_FILMAT11]
             or switch[SW_FAQPROXY] or switch[SW_SETVIEW] or switch[SW_SOUNDS]
             or switch[SW_SETPAUSE] or switch[SW_JAR] or switch[SW_BFLASH]
             or switch[SW_POWERUPS] or switch[SW_AMBIENT] or switch[SW_FADEIN]
             or switch[SW_VOLUME] or switch[SW_LIGHTON] or switch[SW_WEIRD];
     printing:=switch[SW_DEMSTATS] or switch[SW_SDQIMP] or switch[SW_OUTPUT]
                                   or switch[SW_EXTRACT] or switch[SW_SPEED];
     if not rewriting and not printing then ewriteln('demtool: no switches');
     if rewriting and printing then
        ewriteln('demtool: incompatible switches');
     dirpath:='*';
     if paramcount>=pp then dirpath:=paramstr(pp);
     append_dem(dirpath);
     num:=0;
     findfirst(dirpath,archive,sr);
     while doserror=0 do begin
           inc(num);
           levels[num]:=sr.name;
           findnext(sr);
     end;
     if num<1 then
        ewriteln('demtool: '+dirpath+' not found');
     if (num>1) and (paramcount>pp) and rewriting then
        ewriteln('demtool: outfile specified, but there''s more than one infile');
     outfile:=(paramcount>pp);
     if outfile then begin
        outname:=paramstr(pp+1);
        if rewriting then append_dem(outname)
        else begin
             assign(stdout,outname);
             rewrite(stdout);
             reg.ah:=$46;
             reg.cx:=1; reg.bx:=stdrec.handle;
             intr($21,reg);
             close(stdout);
        end;
     end;
     j:=0;
     for i:=1 to length(dirpath) do if dirpath[i]='\' then j:=i;
     dirpath[0]:=chr(j);
     for i:=1 to num do begin
         if printing then write('// ');
         writeln('processing '+dirpath+levels[i]);
         dme_conv(dirpath+levels[i],'tmp.$$$');
         if rewriting then begin
            if outfile then begin
                assign(f,outname);            erase(f);
                assign(f,'tmp.$$$');          rename(f,outname);
            end else begin
                assign(f,dirpath+levels[i]);  erase(f);
                assign(f,'tmp.$$$');          rename(f,dirpath+levels[i]);
            end
         end else begin
            assign(f,'tmp.$$$');              erase(f);
         end;
         if (i<num) and printing then writeln;
     end;
     close(stderr);
     halt(0);
end.
